// Wegen CoInitializeEx
#define _WIN32_DCOM

#include <windows.h>
#include <initguid.h>
#include <cstdio>
#include "AvrDisassembler.h"

unsigned char strCode[] =
{
    0x0D, 0xC0, 0x0C, 0xC0, 0x0B, 0xC0, 0x0A, 0xC0, 0x09, 0xC0, 0x08, 0xC0, 0x07, 0xC0, 0x06, 0xC0,
    0x05, 0xC0, 0x04, 0xC0, 0x03, 0xC0, 0x02, 0xC0, 0x01, 0xC0, 0x00, 0xC0, 0x0F, 0xED, 0x0D, 0xBF,
    0x0F, 0xEF, 0x07, 0xBB, 0x88, 0x94, 0x00, 0x1F, 0x20, 0xF4, 0x00, 0x00, 0x08, 0xBB, 0x07, 0xD0,
    0xFA, 0xCF, 0x07, 0x95, 0xC0, 0xF7, 0x00, 0x00, 0x08, 0xBB, 0x01, 0xD0, 0xFA, 0xCF, 0x1F, 0xB7,
    0x2A, 0x95, 0xF1, 0xF7, 0x3A, 0x95, 0xE1, 0xF7, 0x1F, 0xBF, 0x08, 0x95
};

void __cdecl CleanUp(void)
{
    CoUninitialize();
}

// Wer die Ausgabe in eine Datei umleitet, kann das Ergebnis
// erneut mit dem AVR Assembler assemblieren.
int main(void)
{
    IAvrDisassembler*   pDasm = NULL;
    unsigned long       ulInstrID, ulCycles, ulBytes = 0, ulAddress;
    InstrFlags          eFlags;
    BSTR                bstrStatement, bstrDescription;

    CoInitializeEx(NULL, COINIT_MULTITHREADED); // Muss(!) ein MTA initialisieren
    atexit(CleanUp);

    if(FAILED(CoCreateInstance(CLSID_AvrDisassembler, NULL, CLSCTX_SERVER, IID_IAvrDisassembler, (void**)&pDasm)))
    {
        wprintf(L"CoCreateInstance failed.\n");
        return(0);
    }

    pDasm->Init();
    wprintf(L"; Kleines Lauflicht an PORTB\n");
    wprintf(L".include \"2313def.inc\"\n\n");

    for(int x = 0; x < sizeof(strCode); x += ulBytes)
    {
        bstrStatement = bstrDescription = NULL;
        pDasm->Disassemble(&strCode[x], &ulInstrID, &bstrStatement, &bstrDescription, &ulCycles, &ulBytes, &eFlags, &ulAddress);

        // Bei relativen Verzweigungen das fuehrende '+' ausblenden,
        // da der AVR Assembler das nicht schluckt.
        if(eFlags & IFRel)
        {
            WCHAR* pwcPlus = wcschr(bstrStatement, L'+');

            if(pwcPlus)
                *pwcPlus = L' ';
        }

        wprintf(L"\t%s\t\t; %s (%u)\n", bstrStatement, bstrDescription, ulCycles);
        SysFreeString(bstrStatement);
        SysFreeString(bstrDescription);
    }

    pDasm->Release();
    return(0);
}
